let table;

function preload() {
    table = loadTable(
        "https://gist.githubusercontent.com/olga-kondr/952bf1986c1237cb65dfa52e96695cac/raw/b89456cc5bb5d8f1388e9c7ed3a92fce07745abb/money_earned.csv", 
        "csv", 
        "header"
    );
}

function setup() {
    createCanvas(800, 800);
    background(250);
}
  
function draw() {
    noStroke();
    fill(150, 150, 150);
    textSize(16);
    text('Tickets Sold for the Movie of the Year', 280, 40);
    textSize(12);

    noStroke();
    fill(150, 150, 150);
    text('for 1995 - 2021 year period.', 330, 70);

    noStroke();
    text('0 m', 295, 765);
    text('100 m', 335, 765);
    text('200 m', 390, 765);
    text('300 m', 440, 765);
    text('400 m', 490, 765);
    text('500 m', 540, 765);
    text('600 m', 590, 765);
    text('700 m', 640, 765);
    text('800 m', 690, 765);
    text('900 m', 740, 765);

    stroke(color(190, 190, 190));
    line(350, 750, 350, 100);
    line(400, 750, 400, 100);
    line(450, 750, 450, 100);
    line(500, 750, 500, 100);
    line(550, 750, 550, 100);
    line(600, 750, 600, 100);
    line(650, 750, 650, 100);
    line(700, 750, 700, 100);
    line(750, 750, 750, 100);
  
    noStroke();
    push();
    let axisy = radians(270);
    translate(20, 180);
    rotate(axisy);
    textSize(16);
    text("Movie by Year (Ascending)", -280, 0);
    textSize(12);
    pop();
    
    let plot_start = 300;
    let y = 0;
    let x = 0;
    for (let r = 0; r < table.getRowCount(); r++) {
        let rowIndex = table.getRowCount() - r - 1;
        textAlign(RIGHT);
        text(table.getString(rowIndex, 0), 285, 120+r*24);
        textAlign(LEFT);
        stroke(color(190, 190, 190));
      // the line continued to the name of the movie for users' convenience
        y = 116+r*24;
        line(295, y, 780, y)
        noStroke();
        fill('green')
        amount = table.get(rowIndex,1); 
        x = amount/2000000 + plot_start;
        circle(x, y, 16);
        fill(150, 150, 150);
    }
    stroke(color(0, 0, 0));
    line(300, 750, 300, 100);
    line(300, 750, 780, 750);
    noStroke();
    textSize(16);
    text('Tickets Sold in Millions', 360, 790);
    textSize(12);
}
